/*
 * Copyright (c) 2004 Chirok Han
 *
 * This file is part of fig2pstricks.
 *
 * Fig2pstricks is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Fig2pstricks is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with fig2pstricks; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * Contact: beanerjo@yahoo.com
 */

#include "fig2pstricks.h"
#include "extern.h"

double unit2cm(int x)
{
    return (double)x*2.54/(double)resolution;
}

double thick2cm(int x)
{
    return (double)x*2.54/80.0;
}

void fprint_xy(FILE *fp, int nx, int ny)
{
    fprintf(fp, "(%.2f,%.2f)", 
	    unit2cm(nx), unit2cm(y_boundary-ny));
}

void fprint_xy4(FILE *fp, int nx, int ny, int ybdry)
{
    fprintf(fp, "(%.2f,%.2f)", 
	    unit2cm(nx), unit2cm(ybdry-ny));
}

void fprint_xy_cm(FILE *fp, int nx, int ny)
{
    fprintf(fp, "(%.2fcm,%.2fcm)", 
	    unit2cm(nx), unit2cm(y_boundary-ny));
}

void fprint_xy_cm4(FILE *fp, int nx, int ny, int ybdry)
{
    fprintf(fp, "(%.2fcm,%.2fcm)", 
	    unit2cm(nx), unit2cm(ybdry-ny));
}
